﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace XDGRecursiveDataStructureDemo
{
    public class ViewModel
    {
        public ObservableCollection<SampleData> Data { get; set; }

        string[] names = "Andrew;Alex;Jen;Steve;Murphy;Eric;Tom;Jessica;Pamela;Valerie;Devin;Rob".Split(';');

        Random r = new Random();
        public ViewModel()
        {
            Data = new ObservableCollection<SampleData>();

            for (int i = 0; i < 5; i++)
            {
                SampleData sd1 = new SampleData() { ID = i, Age = r.Next(100), Married = (i % 2 == 0), Name = names[r.Next(names.Length)] };

                if (i != 3)
                {
                    sd1.Kids = new ObservableCollection<SampleData>();

                    for (int j = 0; j < 3; j++)
                    {
                        SampleData sd2 = new SampleData() { ID = j, Age = r.Next(100), Married = (i % 2 == 0), Name = names[r.Next(names.Length)] };

                        if (i != 2)
                        {
                            sd2.Kids = new ObservableCollection<SampleData>();
                            for(int k=0; k<3; k++)
                            {
                                SampleData sd3 = new SampleData() { ID = k, Age = r.Next(100), Married = (i % 2 == 0), Name = names[r.Next(names.Length)] }; 
                                if (i == 1)
                                {
                                    sd3.Kids = new ObservableCollection<SampleData>();

                                    for(int l=0; l<2; l++)
                                    {
                                        SampleData sd4 = new SampleData() { ID = l, Age = r.Next(100), Married = (i % 2 == 0), Name = names[r.Next(names.Length)] };
                                        sd3.Kids.Add(sd4);
                                    }
                                }

                                sd2.Kids.Add(sd3);
                            }                                                        
                        }
                        sd1.Kids.Add(sd2);
                    }
                }

                Data.Add(sd1);
            }
        }
    }

    public class SampleData
    {
        public int ID { get; set; }
        public string Name { get; set; }
        public int Age { get; set; }
        public ObservableCollection<SampleData> Kids { get; set; }

        public bool Married { get; set; }
    }
}
